""" Generator functions related to trial and test functions and the accumulation loop"""

from dune.perftool.pdelab import dune_symbol, dune_preamble


@dune_symbol
def name_testfunction(arg, index, grad, restriction):
    if len(arg.ufl_element().sub_elements()) > 0:
        pass
    return "{}a{}".format("grad_" if grad else "", arg.number())

@dune_symbol
def name_trialfunction(arg, index, grad, restriction):
    return "{}c{}".format("grad_" if grad else "", arg.count())

@dune_symbol
def name_testfunctionspace(*a):
    #TODO
    return "lfsv"

@dune_symbol
def name_trialfunctionspace(*a):
    #TODO
    return "lfsu"

def name_argumentspace(arg, *others):
    if arg.number() == 0:
        return name_testfunctionspace(arg, *others)
    if arg.number() == 1:
        return name_trialfunctionspace(arg, *others)
    # We should never encounter an argument other than 0 or 1
    assert False

@dune_symbol
def name_residual():
    return "r"
